program Win2Dos; { By A.Rossetti & N.Ferrando, 18/10/97 }

{$B-,G+,I-,R-,S-,V-}
{$M 2048,6194,196608}

uses   Objects,crt,dos,personal, windostab;
{La tabella si chiama windostab. In tp7 esiste gi una unit windos.}


type
	Buf = array[0..65534] of Char;

var
	StreamIn, StreamOut: TBufStream;
	D: DirStr;
	N: NameStr;
	E: ExtStr;
	Nome1, Nome2: PathStr;
	SRec: SearchRec;
	Contatore, TotKb: Integer;
	PBuf: ^Buf;
	BufSize: Word;
	Size: LongInt;
	J: Byte;
	Reverse,over: Boolean;

procedure InfoAutor;
begin
	DirectVideo := True;
	GotoXY(1,WhereY);
	WriteLn('Questo programma  stato realizzato da Alessandro Rossetti e Nicola Ferrando');
	WriteLn('come programma di pubblico dominio.');
	WriteLn('Esso pu essere liberamente copiato e distribuito, purch non vi sia');
	WriteLn('scopo di lucro e l''eventuale prezzo pagato ricopra esclusivamente');
	WriteLn('il costo del supporto magnetico per la memorizzazione.');
	WriteLn('Vista la semplicit d''uso, non  fornita alcuna documentazione.');
	WriteLn;
	WriteLn('Per segnalare eventuali errori, critiche al programma o suggerimenti,');
	WriteLn('puoi utilizzare i seguenti recapiti:');
	WriteLn;
	WriteLn('Alessandro Rossetti            Nicola Ferrando');
	WriteLn('Via Mordini 51                 Via Bellavitis 54');
	WriteLn('55100 Lucca                    36100 Vicenza');
	WriteLn('Tel/fax:');
	WriteLn('0583/49.60.93                  0444/50.01.33');
	WriteLn('Posta elettronica:');
	WriteLn('rossetti@comune.lucca.it       nicfer@itn.it');
	WriteLn('                               Fidonet: 2:333/211.20');
end;

procedure Esegui;
label Fine;
var
	OldX: Byte;
	BytesTransfert, P: Word;
begin
	Write(Nome1,' -> ',Nome2,' (',(SRec.Size + 1023) shr 10,' Kb): ');
	OldX := WhereX;
	Inc(TotKb, (SRec.Size + 1023) shr 10);
	while StreamIn.Status = stOk do
	begin
		if BufSize <= Size - StreamIn.GetPos then BytesTransfert := BufSize
			else BytesTransfert := Size - StreamIn.GetPos;
		if BytesTransfert = 0 then goto Fine;
		StreamIn.Read(PBuf^, BytesTransfert);
		for P := 1 to BytesTransfert do if not Reverse then
		begin
			if PBuf^[P] in [#200,#212] then
			begin
				StreamOut.Write(PBuf^, P-1);
				StreamOut.Write(Egrave, 2);
				StreamIn.Seek(StreamIn.GetPos - (BytesTransfert - P));
				if BufSize <= Size - StreamIn.GetPos then BytesTransfert := BufSize
					else BytesTransfert := Size - StreamIn.GetPos;
				if BytesTransfert = 0 then goto Fine;
				StreamIn.Read(PBuf^, BytesTransfert);
				J := 0; {Ricomincia il ciclo for J}
			end
			else
			begin
				for J := 1 to MaxChars do if PBuf^[P] = CharTable[J].WinChar then
				begin
					PBuf^[P] := CharTable[J].DosChar;
					Break; {Esce dal ciclo for J}
				end;
			end;
		end
		else { Reverse }
		begin
			if PBuf^[P] in [#200,#212] then
			begin
				StreamOut.Write(PBuf^, P-1);
				StreamOut.Write(Egrave, 2);
				StreamIn.Seek(StreamIn.GetPos - (BytesTransfert - P));
				if BufSize <= Size - StreamIn.GetPos then BytesTransfert := BufSize
					else BytesTransfert := Size - StreamIn.GetPos;
				if BytesTransfert = 0 then goto Fine;
				StreamIn.Read(PBuf^, BytesTransfert);
				J := 0; {Ricomincia il ciclo for J}
			end
			else
			begin
				for J := 1 to MaxChars do if PBuf^[P] = CharTable[J].DosChar then
				begin
					PBuf^[P] := CharTable[J].WinChar;
					Break;
				end;
			end;
		end;
		GotoXY(OldX,WhereY); Write(((StreamIn.GetPos-P) * 100) div Size,'%');
		StreamOut.Write(PBuf^, P);
		if P = 1 then Break;
	end;
Fine:
	StreamIn.Done;
	StreamOut.Done;
	GotoXY(OldX,WhereY); WriteLn('convertito');
	Inc(Contatore);
	Nome2 := '';
end;

procedure ApriFiles;

procedure CreaDest;
begin
	Nome2 := FExpand(Nome2);
	StreamOut.Init(Nome2, stCreate, MaxAvail - 2049);
	if StreamOut.Status <> stOk then
	begin

		WriteLn('Impossibile creare o scrivere il file ',Nome2,'.');
writeln('Causa:');
case streamout.status of
                4: write('Troppi files aperti. Controlla "files" in config.sys');
5: write('Accesso  negato. Il file  protetto da scrittura.');
                101: write('Errore di scrittura nel disco. Impossibile proseguire.');
150: write('Disco protetto in scrittura.');
152:                write('Disco  non pronto. Inserire un disco e riprovare.');
                157: write('Supporto magnetico sconosciuto.');
                158: write('Settore non trovato durante la scrittura.');
                162: write('Problema hardware sconosciuto. ');
                end;
		Halt(2);
	end;
end;

begin { ApriFiles }
	StreamIn.Init(Nome1, stOpenRead, MaxAvail div 2 - 1025);
	if StreamIn.Status <> stOk then
	begin
		WriteLn('impossibile aprire il file di origine:', nome1,'.');
                case streamin.status of
                2: write('File non trovato.');
                3: write('Directory/percorso  non trovata.');
                4: write('Troppi files aperti. Controlla "Files" in Config.sys');
5:                write('Accesso negato. File gi in uso da altri programmi.');
                6: write('Andle non valido.');
12: write('Codice di accesso errato.');
100: write('Errore nella lettura del disco.');
                152: write('Drive non pronto in lettura. Inserire un disco e riprovare.');
                157: write('Supporto magnetico sconosciuto.');
                end;
		Exit;
	end;
	FSplit(Nome1, D, N, E);
	if Nome2 = '' then
	begin
		if Reverse then E := '.ANS' else E := '.ASC';
		Nome2 := D + N + E;
	end;
	Size := StreamIn.GetSize;
	if Size = 0 then
	begin
		WriteLn('Il file ',Nome1,'  vuoto!');
		Exit;
	end;
	if IsFile(Nome2) and not over  then
	begin
		Write('Il file ',Nome2,' esiste gi. Sovrascriverlo (S/N)?S');
		GotoXY(WhereX-1,WhereY);
		if not Yes then
		begin
			Nome2 := '';
			Exit;
		end;
	end;
	CreaDest;
	DirectVideo := True;
	Esegui;
	DirectVideo := False;
end;

procedure ApriLista;
var
	Lista: Text;
	NomeLista: PathStr;
begin
	NomeLista := Copy(Nome1, 2, Length(Nome1)-1);
	Assign(Lista, NomeLista);
	Reset(Lista);
	if IOResult > 0 then
	begin
		WriteLn('File della lista non trovato.');
		Halt(4);
	end;
	Write('Conversione ');
	if not Reverse then Write('Windows -> DOS') else Write('DOS -> Windows');
	WriteLn;
	while not Eof(Lista) do
	begin
		ReadLn(Lista, Nome1);
		Nome1 := FExpand(Nome1);
		FindFirst(Nome1, Archive + Readonly, SRec);
		FSplit(Nome1, D, N, E);
		if DosError > 0 then
		begin
			E := '.TXT';
			Nome1 := D + N + E;
			FindFirst(Nome1, Archive+ Readonly, SRec);
			if DosError > 0 then WriteLn('File non trovato: ',Nome1,'.');
		end;
		while DosError = 0  do
		begin
			ApriFiles;
			FindNext(SRec);
		end;
	end;
	Close(Lista);
end;

procedure Istruzioni;
begin
	WriteLn('Win2Dos/Dos2Win. Versione 2.2. (C) 1997 Alessandro Rossetti & Nicola Ferrando.');
	WriteLn('Conversione di file di testo da Windows a DOS e viceversa.');

	WriteLn;

        writeln('Revisione: 20 Ottobre 1997.');
	WriteLn('Sintassi:  WIN2DOS [/R] FILE1[.EXT] | @LISTA[/o] [file2[.ext]]  | [FILE2[.EXT]]');
	WriteLn;
	WriteLn('dove: ');
	WriteLn('/R = converte dal formato DOS al formato Windows (per default la conversione');
	WriteLn('avviene da Windows a DOS)');
	WriteLn('FILE1[.EST] = file di testo da convertire. Esso pu essere scritto con');
	WriteLn('un editor di testi per Windows o Windows95, per la conversione DOS, mentre');
	WriteLn('per quella contraria il testo deve essere un file ASCII puro.');
	WriteLn('Se non viene specificata l''estensione, viene sempre assunta .TXT.');
	WriteLn('FILE2[.EST] = file convertito nel formato scelto');
	WriteLn;
	WriteLn('I files convertiti avranno lo stesso nome ed estensione diversa (".ASC"=testo');
	WriteLn('DOS, ".ANS"=testo Windows), se non viene immesso un nome di file per la');
	WriteLn('destinazione.');
writeln('/O: sovrascrive i files convertiti esistenti automaticamente.');
	WriteLn('FILE1 pu contenere caratteri jolly.');
	WriteLn('Se il primo parametro  @NOMEFILE, i nomi dei file da convertire');
	WriteLn('verranno letti dalla lista-files.');
	WriteLn;
	Pause;
	GotoXY(1,WhereY); ClrEol;
	WriteLn('Note:');
	Writeln('1) Nel caso di conversioni multiple, i file origine devono essere frutto di');
	WriteLn('uno stesso tipo di sorgente: tutti files ASCII (8 bit)/tutti files ANSI.');
	WriteLn('2) Il set di caratteri Windows si basa sulla tabella codici 850.');
	WriteLn;
	Pause;
	InfoAutor;
	Halt;
end;

{ Programma principale }

begin
	Reverse := False;
	DirectVideo := False;
	if ParamCount = 0 then Istruzioni;
	Nome1 := UpperStr(ParamStr(1));
	Nome2 := UpperStr(ParamStr(2));
	if Nome1[1] in ['/','-'] then if Nome1[2] = 'R' then
	begin
		Reverse := True;
                over:=false;
		Nome1 := Nome2;
		Nome2 := UpperStr(ParamStr(3));
	end else Istruzioni;

	if Nome2 = Nome1 then
	begin
		Sound(100); Delay(70); Nosound;
		WriteLn('Errore! Origine e destinazione devono avere nomi diversi.');
		Halt(1);
	end;

	Contatore := 0;
	BufSize := MaxAvail div 3;
	GetMem(PBuf, BufSize);
if nome2[1] in['-','/'] then if nome2[2]=upcase('O') then begin
nome2:=upperstr(paramstr(3));
over:=true;
end;
if Nome1[1] = '@' then
		ApriLista
	else
	begin
		Nome1 := FExpand(Nome1);
		FindFirst(Nome1, Archive + Readonly, SRec);
		FSplit(Nome1, D, N, E);
		if DosError > 0 then
		begin
			E := '.TXT';
			Nome1 := D + N + E;
			FindFirst(Nome1, Archive+ Readonly, SRec);
			if DosError > 0 then
			begin
				WriteLn('Non ci sono files da convertire.');
				Halt(1);
			end;
		end;
		Write('Conversione ');
		if not Reverse then Write('Windows -> DOS') else Write('DOS -> Windows');
		WriteLn;
		while DosError = 0 do
		begin
			Nome1 := D + SRec.Name;
			ApriFiles;
			FindNext(SRec);
		end;
	end;

	FreeMem(PBuf, BufSize);
	DirectVideo := False;
	if Contatore > 0 then
	begin
		WriteLn;
		if Contatore > 1 then Write('Sono stati convertiti ') else Write('E` stato convertito ');
		WriteLn(Contatore,' file.');
		WriteLn('Dimensione complessiva:   ',TotKb,' Kb.');
	end else WriteLn('Nessun file convertito.');
	WriteLn;
	Pause;
	InfoAutor;
end.
